# - Find the nde-globalkeys include and library dirs and define a some macros
#
# The module defines the following variables
#  NDE_GLOBALKEYS_FOUND         - Set to TRUE if all of the above has been found
#
# Typical usage:
#    find_package(nde-globalkeys)
#    add_executable(use-nde-globalkeys main.cpp)
#    target_link_libraries(use-nde-globalkeys nde-globalkeys)


####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was nde_globalkeys-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

if (CMAKE_VERSION VERSION_LESS 3.0.2)
    message(FATAL_ERROR \"nde-globalkeys requires at least CMake version 3.0.2\")
endif()

include(CMakeFindDependencyMacro)

set(NDE_GLOBALKEYS_MAJOR_VERSION 0)
set(NDE_GLOBALKEYS_MINOR_VERSION 0)
set(NDE_GLOBALKEYS_PATCH_VERSION 1)
set(NDE_GLOBALKEYS_VERSION 0.0.1)

find_dependency(Qt5Widgets)
find_dependency(Qt5DBus)

if (NOT TARGET nde-globalkeys)
    if (POLICY CMP0024)
        cmake_policy(SET CMP0024 NEW)
    endif()
    include("${CMAKE_CURRENT_LIST_DIR}/nde-globalkeys-targets.cmake")
endif()
